commit 2d31587003068f754f1c662c620964cbdd99750f
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Mon May 11 13:10:28 2020 +0200

    Documentation massively overhauled:
    - Remote Procedure Call system massively reworked.
    - Component diagram slightly enhanced.
    - Several fixes.

diff --git a/doc/classdiagrams/config.svg b/doc/classdiagrams/config.svg
index 5913733..4467300 100644
--- a/doc/classdiagrams/config.svg
+++ b/doc/classdiagrams/config.svg
@@ -1,5 +1,5 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="290px" preserveAspectRatio="none" style="width:308px;height:290px;" version="1.1" viewBox="0 0 308 290" width="308px" zoomAndPan="magnify"><defs><filter height="300%" id="fvia6mr5z56ky" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><text fill="#000000" font-family="sans-serif" font-size="18" font-weight="bold" lengthAdjust="spacingAndGlyphs" textLength="89" x="107.5" y="16.708">µRtWare</text><text fill="#000000" font-family="sans-serif" font-size="18" lengthAdjust="spacingAndGlyphs" textLength="120" x="92" y="37.6611">Configuration</text><!--MD5=[e443ac33c80100c2d54e1f5fe669f6d7]
-class urt_config--><rect fill="#FEFECE" filter="url(#fvia6mr5z56ky)" height="230.4609" id="urt_config" style="stroke: #A80036; stroke-width: 1.5;" width="290" x="7" y="48.9063"/><ellipse cx="116.75" cy="64.9063" fill="#BFBFBF" rx="11" ry="11" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M119.7188,70.5469 Q119.1406,70.8438 118.5,70.9844 Q117.8594,71.1406 117.1563,71.1406 Q114.6563,71.1406 113.3281,69.5 Q112.0156,67.8438 112.0156,64.7188 Q112.0156,61.5938 113.3281,59.9375 Q114.6563,58.2813 117.1563,58.2813 Q117.8594,58.2813 118.5,58.4375 Q119.1563,58.5938 119.7188,58.8906 L119.7188,61.6094 Q119.0938,61.0313 118.5,60.7656 Q117.9063,60.4844 117.2813,60.4844 Q115.9375,60.4844 115.25,61.5625 Q114.5625,62.625 114.5625,64.7188 Q114.5625,66.8125 115.25,67.8906 Q115.9375,68.9531 117.2813,68.9531 Q117.9063,68.9531 118.5,68.6875 Q119.0938,68.4063 119.7188,67.8281 L119.7188,70.5469 Z "/><text fill="#000000" font-family="sans-serif" font-size="12" lengthAdjust="spacingAndGlyphs" textLength="62" x="137.25" y="69.0605">urt_config</text><line style="stroke: #A80036; stroke-width: 1.5;" x1="8" x2="296" y1="80.9063" y2="80.9063"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="159" x="13" y="95.1167">URT_CFG_DELAY_WIDTH : int</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="169" x="13" y="107.9214">URT_CFG_TOPICID_WIDTH : int</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="182" x="13" y="120.7261">URT_CFG_SERVICEID_WIDTH : int</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="194" x="13" y="133.5308">URT_CFG_NODESTAGE_WIDTH : int</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="8" x2="296" y1="140.125" y2="140.125"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="190" x="13" y="154.3354">URT_CFG_DEBUG_ENABLED : bool</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="8" x2="296" y1="160.9297" y2="160.9297"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="197" x="13" y="175.1401">URT_CFG_PUBSUB_ENABLED : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="204" x="13" y="187.9448">URT_CFG_PUBSUB_PROFILING : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="278" x="13" y="200.7495">URT_CFG_PUBSUB_QOS_DEADLINECHECKS : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="252" x="13" y="213.5542">URT_CFG_PUBSUB_QOS_RATECHECKS : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="258" x="13" y="226.3589">URT_CFG_PUBSUB_QOS_JITTERCHECKS : bool</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="8" x2="296" y1="232.9531" y2="232.9531"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="172" x="13" y="247.1636">URT_CFG_RPC_ENABLED : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="179" x="13" y="259.9683">URT_CFG_RPC_PROFILING : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="233" x="13" y="272.7729">URT_CFG_RPC_QOS_JITTERCHECKS : bool</text><!--MD5=[fa463d24fc3844a76136af04696c4d0a]
+<?xml version="1.0" encoding="UTF-8" standalone="no"?><svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" contentScriptType="application/ecmascript" contentStyleType="text/css" height="346px" preserveAspectRatio="none" style="width:308px;height:346px;" version="1.1" viewBox="0 0 308 346" width="308px" zoomAndPan="magnify"><defs><filter height="300%" id="f19u4eu9l1i7d5" width="300%" x="-1" y="-1"><feGaussianBlur result="blurOut" stdDeviation="2.0"/><feColorMatrix in="blurOut" result="blurOut2" type="matrix" values="0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 .4 0"/><feOffset dx="4.0" dy="4.0" in="blurOut2" result="blurOut3"/><feBlend in="SourceGraphic" in2="blurOut3" mode="normal"/></filter></defs><g><text fill="#000000" font-family="sans-serif" font-size="18" font-weight="bold" lengthAdjust="spacingAndGlyphs" textLength="89" x="107.5" y="16.708">µRtWare</text><text fill="#000000" font-family="sans-serif" font-size="18" lengthAdjust="spacingAndGlyphs" textLength="120" x="92" y="37.6611">Configuration</text><!--MD5=[e443ac33c80100c2d54e1f5fe669f6d7]
+class urt_config--><rect fill="#FEFECE" filter="url(#f19u4eu9l1i7d5)" height="286.4844" id="urt_config" style="stroke: #A80036; stroke-width: 1.5;" width="290" x="7" y="48.9063"/><ellipse cx="116.75" cy="64.9063" fill="#BFBFBF" rx="11" ry="11" style="stroke: #A80036; stroke-width: 1.0;"/><path d="M119.7188,70.5469 Q119.1406,70.8438 118.5,70.9844 Q117.8594,71.1406 117.1563,71.1406 Q114.6563,71.1406 113.3281,69.5 Q112.0156,67.8438 112.0156,64.7188 Q112.0156,61.5938 113.3281,59.9375 Q114.6563,58.2813 117.1563,58.2813 Q117.8594,58.2813 118.5,58.4375 Q119.1563,58.5938 119.7188,58.8906 L119.7188,61.6094 Q119.0938,61.0313 118.5,60.7656 Q117.9063,60.4844 117.2813,60.4844 Q115.9375,60.4844 115.25,61.5625 Q114.5625,62.625 114.5625,64.7188 Q114.5625,66.8125 115.25,67.8906 Q115.9375,68.9531 117.2813,68.9531 Q117.9063,68.9531 118.5,68.6875 Q119.0938,68.4063 119.7188,67.8281 L119.7188,70.5469 Z "/><text fill="#000000" font-family="sans-serif" font-size="12" lengthAdjust="spacingAndGlyphs" textLength="62" x="137.25" y="69.0605">urt_config</text><line style="stroke: #A80036; stroke-width: 1.5;" x1="8" x2="296" y1="80.9063" y2="80.9063"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="159" x="13" y="111.9214">URT_CFG_DELAY_WIDTH : int</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="194" x="13" y="124.7261">URT_CFG_NODESTAGE_WIDTH : int</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="8" x2="130.5" y1="95.3086" y2="95.3086"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="43" x="130.5" y="98.6167">general</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="173.5" x2="296" y1="95.3086" y2="95.3086"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="197" x="13" y="154.3354">URT_CFG_PUBSUB_ENABLED : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="222" x="13" y="167.1401">URT_CFG_PUBSUB_TOPICID_WIDTH : int</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="204" x="13" y="179.9448">URT_CFG_PUBSUB_PROFILING : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="278" x="13" y="192.7495">URT_CFG_PUBSUB_QOS_DEADLINECHECKS : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="252" x="13" y="205.5542">URT_CFG_PUBSUB_QOS_RATECHECKS : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="258" x="13" y="218.3589">URT_CFG_PUBSUB_QOS_JITTERCHECKS : bool</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="8" x2="101.5" y1="137.7227" y2="137.7227"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="101" x="101.5" y="141.0308">publish-subscribe</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="202.5" x2="296" y1="137.7227" y2="137.7227"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="172" x="13" y="247.9683">URT_CFG_RPC_ENABLED : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="210" x="13" y="260.7729">URT_CFG_RPC_SERVICEID_WIDTH : int</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="179" x="13" y="273.5776">URT_CFG_RPC_PROFILING : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="253" x="13" y="286.3823">URT_CFG_RPC_QOS_DEADLINECHECKS : bool</text><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="233" x="13" y="299.187">URT_CFG_RPC_QOS_JITTERCHECKS : bool</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="8" x2="85.5" y1="231.3555" y2="231.3555"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="133" x="85.5" y="234.6636">remote procedure calls</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="218.5" x2="296" y1="231.3555" y2="231.3555"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="190" x="13" y="328.7964">URT_CFG_DEBUG_ENABLED : bool</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="8" x2="134.5" y1="312.1836" y2="312.1836"/><text fill="#000000" font-family="sans-serif" font-size="11" lengthAdjust="spacingAndGlyphs" textLength="35" x="134.5" y="315.4917">debug</text><line style="stroke: #A80036; stroke-width: 1.0; stroke-dasharray: 1.0,2.0;" x1="169.5" x2="296" y1="312.1836" y2="312.1836"/><!--MD5=[b5773c79a01ac53a242ef73d22f7ce2f]
 @startuml
 
 title **µRtWare**\nConfiguration
@@ -17,22 +17,24 @@ title **µRtWare**\nConfiguration
 
 
   class urt_config <<C,BFBFBF>> {
+  .. general ..
   URT_CFG_DELAY_WIDTH : int
-  URT_CFG_TOPICID_WIDTH : int
-  URT_CFG_SERVICEID_WIDTH : int
   URT_CFG_NODESTAGE_WIDTH : int
-  ..
-  URT_CFG_DEBUG_ENABLED : bool
-  ..
+  .. publish-subscribe ..
   URT_CFG_PUBSUB_ENABLED : bool
+  URT_CFG_PUBSUB_TOPICID_WIDTH : int
   URT_CFG_PUBSUB_PROFILING : bool
   URT_CFG_PUBSUB_QOS_DEADLINECHECKS : bool
   URT_CFG_PUBSUB_QOS_RATECHECKS : bool
   URT_CFG_PUBSUB_QOS_JITTERCHECKS : bool
-  ..
+  .. remote procedure calls ..
   URT_CFG_RPC_ENABLED : bool
+  URT_CFG_RPC_SERVICEID_WIDTH : int
   URT_CFG_RPC_PROFILING : bool
+  URT_CFG_RPC_QOS_DEADLINECHECKS : bool
   URT_CFG_RPC_QOS_JITTERCHECKS : bool
+  .. debug ..
+  URT_CFG_DEBUG_ENABLED : bool
 }
 
 
@@ -45,7 +47,7 @@ PlantUML version 1.2020.00(Sat Jan 11 13:30:53 CET 2020)
 (GPL source distribution)
 Java Runtime: OpenJDK Runtime Environment
 JVM: OpenJDK 64-Bit Server VM
-Java Version: 11.0.6+10-post-Ubuntu-1ubuntu118.04.1
+Java Version: 11.0.7+10-post-Ubuntu-2ubuntu218.04
 Operating System: Linux
 Default Encoding: UTF-8
 Language: en