commit b36942235087d1c658dbfabb2dd907a9ce372037
Author: Robert Haschke <rhaschke@techfak.uni-bielefeld.de>
Date:   Mon Oct 26 01:37:04 2020 +0100

    Fix warnings

diff --git a/client/cpp/CMakeLists.txt b/client/cpp/CMakeLists.txt
index 62ed9b5..2c5965f 100644
--- a/client/cpp/CMakeLists.txt
+++ b/client/cpp/CMakeLists.txt
@@ -35,7 +35,7 @@ option(IGNORE_RSB "IGNORE_RSB" OFF)
 IF (IGNORE_RSB)
     MESSAGE(INFO "RSB disabled per command line flag IGNORE_RSB")
 ELSE (IGNORE_RSB)
-FIND_PACKAGE(RSB 0.11)
+FIND_PACKAGE(RSB 0.11 QUIET)
 IF (RSB_FOUND)
     #RSB
     SET(CMAKE_INSTALL_RPATH "\$ORIGIN/../lib:\$ORIGIN/")
@@ -62,13 +62,15 @@ IF (RSB_FOUND)
 
     message(STATUS "RSB Support is ON")
     add_definitions(-DRSB_SUPPORT=1)
-ENDIF (RSB_FOUND)
+ELSE(RSB_FOUND)
+    message(STATUS "RSB not found.")
+ENDIF(RSB_FOUND)
 ENDIF(IGNORE_RSB)
 
 ################################################################
 # check for ROS support:
-find_package(catkin)
-IF (catkin_FOUND)
+find_package(catkin QUIET)
+IF(catkin_FOUND)
     SET(ROS_FOUND 1)
 
     catkin_package(
@@ -81,7 +83,9 @@ IF (catkin_FOUND)
     message(STATUS "ROS Support is ON")
     add_definitions(-DROS_SUPPORT=1)
     include_directories(${catkin_INCLUDE_DIRS})
-ENDIF (catkin_FOUND)
+ELSE(catkin_FOUND)
+    message(STATUS "ROS not found.")
+ENDIF(catkin_FOUND)
 
 add_definitions ("-Wall")
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x -fstack-protector-all ")
@@ -91,7 +95,7 @@ set(ENV{PKG_CONFIG_PATH} "$ENV{PKG_CONFIG_PATH}:${CMAKE_INSTALL_PREFIX}/lib/pkgc
 find_package( Boost 1.46 REQUIRED COMPONENTS thread program_options system filesystem regex)
 LINK_DIRECTORIES( ${Boost_LIBRARY_DIRS}  )
 include_directories(${Boost_INCLUDE_DIRS} )
-message("-- using ${Boost_LIBRARIES}")
+message(STATUS "using ${Boost_LIBRARIES}")
 
 INCLUDE_DIRECTORIES(${CMAKE_INSTALL_PREFIX}/include)
 
@@ -172,5 +176,3 @@ TARGET_LINK_LIBRARIES(${PROJECT_NAME}_example_random_gaze ${HLRC_CLIENT_LIBNAME}
 #install(TARGETS ${PROJECT_NAME}_calibrate_camera DESTINATION bin)
 ADD_EXECUTABLE(${PROJECT_NAME}_example_speech_test examples/speech_test/main.cpp)
 TARGET_LINK_LIBRARIES(${PROJECT_NAME}_example_speech_test ${HLRC_CLIENT_LIBNAME})
-
-
diff --git a/server/CMakeLists.txt b/server/CMakeLists.txt
index 4768892..fbd4512 100644
--- a/server/CMakeLists.txt
+++ b/server/CMakeLists.txt
@@ -19,7 +19,7 @@ option(IGNORE_RSB "IGNORE_RSB" OFF)
 IF (IGNORE_RSB) 
     MESSAGE(INFO "RSB disabled per command line flag IGNORE_RSB")
 ELSE (IGNORE_RSB)
-FIND_PACKAGE(RSB 0.11)
+FIND_PACKAGE(RSB 0.11 QUIET)
 IF (RSB_FOUND)
     #RSB
     SET(CMAKE_INSTALL_RPATH "\$ORIGIN/../lib:\$ORIGIN/")
@@ -46,12 +46,14 @@ IF (RSB_FOUND)
 
     message(STATUS "RSB Support is ON")
     add_definitions(-DRSB_SUPPORT=1)
+ELSE(RSB_FOUND)
+    message(STATUS "RSB not found.")
 ENDIF (RSB_FOUND)
 ENDIF(IGNORE_RSB)
 
 ################################################################
 # check for ROS support:
-find_package(catkin)
+find_package(catkin QUIET)
 IF (catkin_FOUND)
     SET(ROS_FOUND 1)
 
@@ -101,31 +103,25 @@ IF (catkin_FOUND)
         #CATKIN_DEPENDS message_runtime
         #DEPENDS system_lib
     )
-ENDIF (catkin_FOUND)
+ELSE(catkin_FOUND)
+    message(STATUS "ROS not found.")
+ENDIF(catkin_FOUND)
 
 add_definitions ("-Wall")
 
 ###################################
 # humotion
 INCLUDE(FindPkgConfig)
-find_package(humotion 0.0.1)
-IF (humotion_FOUND)
-        message("> using humotion includes from " ${humotion_INCLUDE_DIRS})
-ELSE (humotion_FOUND)
-        message(FATAL_ERROR "> error: can not find libhumotion")
-endif (humotion_FOUND)
+find_package(humotion 0.0.1 REQUIRED)
+message(STATUS "using humotion includes from " ${humotion_INCLUDE_DIRS})
 
 ###################################
 # libao audio
 PKG_CHECK_MODULES(AO REQUIRED ao>=1.1.0)
-IF (AO_FOUND)
-  SET(AO_LIBRARY_DIRS "${AO_PREFIX}/lib")
-  SET(AO_INCLUDE_DIRS "${AO_PREFIX}/include")
-  SET(AO_LIBRARIES "ao")
-  MESSAGE("using libao version ${AO_VERSION} from ${AO_PREFIX}")
-ELSE (AO_FOUND)
-  message(FATAL_ERROR "Error: Cannot find libao")
-ENDIF (AO_FOUND)
+SET(AO_LIBRARY_DIRS "${AO_PREFIX}/lib")
+SET(AO_INCLUDE_DIRS "${AO_PREFIX}/include")
+SET(AO_LIBRARIES "ao")
+MESSAGE(STATUS "using libao version ${AO_VERSION} from ${AO_PREFIX}")
 
 #build 
 include_directories(include ${catkin_INCLUDE_DIRS} ${EIGEN3_INCLUDE_DIRS} ${Boost_INCLUDE_DIRS} ${humotion_INCLUDE_DIRS} ${AO_INCLUDE_DIRS} ${humotion_INCLUDE_DIRS})
diff --git a/server/src/Utterance.cpp b/server/src/Utterance.cpp
index 719f2f9..0bfac29 100644
--- a/server/src/Utterance.cpp
+++ b/server/src/Utterance.cpp
@@ -109,7 +109,7 @@ string Utterance::currently_active_phoneme(){
     //fetch active symbol:
     string symbol = ((symbol_duration_pair_t)*phonemes_vector_iterator).first;
     //printf("> active symbol = %s\n",symbol.c_str());
-    if (DEBUG_PRINT_PHONEMES) printf("%s ",symbol.c_str()); fflush(stdout);
+    if (DEBUG_PRINT_PHONEMES) { printf("%s ",symbol.c_str()); fflush(stdout); }
 
     return symbol;
 }