commit 46471486302efadc59bfbde603a5238a41eb6a74
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed May 20 12:44:12 2020 +0200

    OSAL slightly reworked.
    Interfaces enhanced.
    Documentation updated.

diff --git a/doc/classdiagrams/osal.uml b/doc/classdiagrams/osal.uml
index 60a5ac3..9bf632c 100644
--- a/doc/classdiagrams/osal.uml
+++ b/doc/classdiagrams/osal.uml
@@ -40,7 +40,7 @@ $group("time") {
       'Retrieves the current time.
     + {method} urtTimeNow (void) : urt_osTime_t
       'Increase a system time object.
-    + {method} urtTimeAddUs (time : urt_osTime_t*, offset : uint32_t) : urt_osTime_t*
+    + {method} urtTimeAddUs (time : urt_osTime_t*, offset : urt_delay_t) : void
   }
 }
 
@@ -96,11 +96,11 @@ $group("timer") {
       'Initializes an urt_osTimer_t object.
     + {method} urtTimerInit (timer : urt_osTimer_t*) : void
       'Sets the timer to a specified delay with specified callback and arguments.
-    + {method} urtTimerSet (timer : urt_osTimer_t*, delay : urt_delay_t, callback : urt_osTimerCallback_t*, parameter : void*) : urt_status_t
+    + {method} urtTimerSet (timer : urt_osTimer_t*, delay : urt_delay_t, callback : urt_osTimerCallback_t*, parameter : void*) : void
       'Sets the timer to a specified period with specified callback and arguments.
-    + {method} urtTimerSetPeriodic (timer : urt_osTimer_t*, period : urt_delay_t, callback : urt_osTimerCallback_t*, parameter : void*) : urt_status_t
+    + {method} urtTimerSetPeriodic (timer : urt_osTimer_t*, period : urt_delay_t, callback : urt_osTimerCallback_t*, parameter : void*) : void
       'Resets the timer.
-    + {method} urtTimerReset (timer : urt_osTimer_t*) : urt_status_t
+    + {method} urtTimerReset (timer : urt_osTimer_t*) : void
       'Check whether the timer is already armed.
     + {method} urtTimerIsArmed (timer : urt_osTimer_t*) : bool
   }
@@ -164,9 +164,9 @@ $group("thread") {
      'Maximum sleep interval in seconds (as float).
     URT_THREAD_SLEEP_MAX : float
       'Maximum sleep interval in seconds.
-    URT_THREAD_SSLEP_MAX : urt_delay_t
+    URT_THREAD_SSLEP_MAX : unsigned int
       'Maximum sleep interval in milliseconds.
-    URT_THREAD_MSLEEP_MAX : urt_delay_t
+    URT_THREAD_MSLEEP_MAX : unsigned int
       'Maximum sleep interval in microseconds.
     URT_THREAD_USLEEP_MAX : urt_delay_t
     --
@@ -174,25 +174,21 @@ $group("thread") {
     + {method} URT_THREAD_MEMORY (varname, stacksize)
     ..
       'Initializes an urt_osThread_t object.
-    + {method} urtThreadInit (memory : void*, size : size_t, func : urt_osThreadFunction_t*) : urt_osThread_t*
+    + {method} urtThreadInit (memory : void*, size : size_t, prio : urt_osThreadPrio_t, func : urt_osThreadFunction_t*, arg : void*) : urt_osThread_t*
       'Starts a thread.
-    + {method} urtThreadStart (thread : urt_osThread_t*, prio : urt_osThreadPrio_t, arg : void*) : void
+    + {method} urtThreadStart (thread : urt_osThread_t*) : void
       'The calling threads yields.
     + {method} urtThreadYield (void) : void
       'Retrieves the priority of the calling thread.
     + {method} urtThreadGetPriority (void) : urt_osThreadPrio_t
       'Sets the priority of the calling thread.
     + {method} urtThreadSetPriority (prio : urt_osThreadPrio_t) : void
-      'Suspends a thread so it will no longer be executed.
-    + {method} urtThreadSuspend (thread : urt_osThread_t*) : void
-      'Wakes a suspended thread.
-    + {method} urtThreadResume (thread : urt_osThread_t*) : urt_status_t
       'Suspends the calling thread for the specified time.
     + {method} urtThreadSleep (seconds : float) : void
       'Suspends the calling thread for the specified time.
-    + {method} urtThreadSSleep (seconds : urt_delay_t) : void
+    + {method} urtThreadSSleep (seconds : unsigned int) : void
       'Suspends the calling thread for the specified time.
-    + {method} urtThreadMSleep (milliseconds : urt_delay_t) : void
+    + {method} urtThreadMSleep (milliseconds : unsigned int) : void
       'Suspends the calling thread for the specified time.
     + {method} urtThreadUSleep (microseconds : urt_delay_t) : void
       'Suspends the calling thread until the specified time.
@@ -259,9 +255,9 @@ $group("events") {
   /' Not a class/type but a set of static event-related functions. '/
   $function("urt_events") {
       'Registers a lister to a source.
-    + {method} urtEventRegister (source : urt_osEventSource_t*, listener : urt_osEventListener_t*, mask : urt_osEventMask_t, flags : urt_osEventFlags_t) : urt_status_t
+    + {method} urtEventRegister (source : urt_osEventSource_t*, listener : urt_osEventListener_t*, mask : urt_osEventMask_t, flags : urt_osEventFlags_t) : void
       'Unregisters a listener from a source.
-    + {method} urtEventUnregister (source _ urt_osEventSource_t*, listener : urt_osEventListener_t*) : urt_status_t
+    + {method} urtEventUnregister (source _ urt_osEventSource_t*, listener : urt_osEventListener_t*) : void
       'Blocks the thread until any event occurs or the timeout expires.
     + {method} urtEventWait (mask : urt_osEventMask_t, type : urt_osEventWait_t, timeout : urt_delay_t) : urt_osEventMask_t
   }