commit 46471486302efadc59bfbde603a5238a41eb6a74
Author: Thomas Schöpping <tschoepp@cit-ec.uni-bielefeld.de>
Date:   Wed May 20 12:44:12 2020 +0200

    OSAL slightly reworked.
    Interfaces enhanced.
    Documentation updated.

diff --git a/inc/urt_confcheck.h b/inc/urt_confcheck.h
index ef82902..ed18b78 100644
--- a/inc/urt_confcheck.h
+++ b/inc/urt_confcheck.h
@@ -3,7 +3,7 @@
 applications. It was developed as part of the software habitat for the
 Autonomous Mini Robot [1] (AMiRo) but can be used for other purposes as well.
 
-Copyright (C) 2018..2019  Thomas Schöpping et al.
+Copyright (C) 2018..2020  Thomas Schöpping et al.
 
 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
@@ -19,37 +19,107 @@ You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 
-#ifndef _URTWARE_CONFCHECK_H_
-#define _URTWARE_CONFCHECK_H_
+#ifndef URT_CONFCHECK_H
+#define URT_CONFCHECK_H
 
-#include <urtwareconf.h>
+#include <urtware.h>
+
+/*============================================================================*/
+/* CONSTANTS                                                                  */
+/*============================================================================*/
+
+/*============================================================================*/
+/* SETTINGS                                                                   */
+/*============================================================================*/
+
+/*============================================================================*/
+/* CHECKS                                                                     */
+/*============================================================================*/
+
+/* general parameters and options */
 
 #if !defined(URT_CFG_DELAY_WIDTH)
-  #error "URT_CFG_DELAY_WIDTH not defined in urtwareconf.h"
-#else
-  #if !(URT_CFG_DELAY_WIDTH == 32 || URT_CFG_DELAY_WIDTH == 64)
-    #error "URT_CFG_DELAY_WIDTH set to illegal value in urtwareconf.h"
-  #endif
-#endif
-
-#if !defined(URT_CFG_TOPICID_WIDTH)
-  #error "URT_CFG_TOPICID_WIDTH not defined in urtwareconf.h"
-#else
-  #if !(URT_CFG_TOPICID_WIDTH == 8 || URT_CFG_TOPICID_WIDTH == 16 || URT_CFG_TOPICID_WIDTH == 32 || URT_CFG_TOPICID_WIDTH == 64)
-    #error "URT_CFG_TOPICID_WIDTH set to illegal value in urtwareconf.h"
-  #endif
-#endif
+# error "URT_CFG_DELAY_WIDTH not defined in urtwareconf.h"
+#endif /* !defined(URT_CFG_DELAY_WIDTH) */
 
 #if !defined(URT_CFG_NODESTAGE_WIDTH)
-  #error "URT_CFG_NODESTAGE_WIDTH not defined in urtwareconf.h"
-#else
-  #if !(URT_CFG_NODESTAGE_WIDTH == 8 || URT_CFG_NODESTAGE_WIDTH == 16 || URT_CFG_NODESTAGE_WIDTH == 32 || URT_CFG_NODESTAGE_WIDTH == 64)
-    #error "URT_CFG_NODESTAGE_WIDTH set to illegal value in urtwareconf.h"
-  #endif
-#endif
-
-#if !defined(URT_CFG_DEBUG)
-  #error "URT_CFG_DEBUG not defined in urtwareconf.h"
-#endif
-
-#endif /* _URTWARE_CONFCHECK_H_ */
+# error "URT_CFG_NODESTAGE_WIDTH not defined in urtwareconf.h"
+#endif /* !defined(URT_CFG_NODESTAGE_WIDTH) */
+
+#if !defined(URT_CFG_DEBUG_ENABLED)
+# error "URT_CFG_DEBUG_ENABLED not defined in urtwareconf.h"
+#endif /* !defined(URT_CFG_DEBUG_ENABLED) */
+
+/* publish-subscribe parameters and options */
+
+#if !defined(URT_CFG_PUBSUB_ENABLED)
+# error "URT_CFG_PUBSUB_ENABLED not defined in urtwareconf.h"
+#endif /* !defined(URT_CFG_PUBSUB_ENABLED) */
+
+#if (URT_CFG_PUBSUB_ENABLED == true)
+
+# if !defined(URT_CFG_PUBSUB_TOPICID_WIDTH)
+#   error "URT_CFG_PUBSUB_TOPICID_WIDTH not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_PUBSUB_TOPICID_WIDTH) */
+
+# if !defined(URT_CFG_PUBSUB_PROFILING)
+#   error "URT_CFG_PUBSUB_PROFILING not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_PUBSUB_PROFILING) */
+
+# if !defined(URT_CFG_PUBSUB_QOS_DEADLINECHECKS)
+#   error "URT_CFG_PUBSUB_QOS_DEADLINECHECKS not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_PUBSUB_QOS_DEADLINECHECKS) */
+
+# if !defined(URT_CFG_PUBSUB_QOS_RATECHECKS)
+#   error "URT_CFG_PUBSUB_QOS_RATECHECKS not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_PUBSUB_QOS_RATECHECKS) */
+
+# if !defined(URT_CFG_PUBSUB_QOS_JITTERCHECKS)
+#   error "URT_CFG_PUBSUB_QOS_JITTERCHECKS not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_PUBSUB_QOS_JITTERCHECKS) */
+
+#endif /* URT_CFG_PUBSUB_ENABLED == true */
+
+/* remote procedure call parameters and options */
+
+#if !defined(URT_CFG_RPC_ENABLED)
+# error "URT_CFG_RPC_ENABLED not defined in urtwareconf.h"
+#endif /* !defined(URT_CFG_RPC_ENABLED) */
+
+#if (URT_CFG_RPC_ENABLED == true)
+
+# if !defined(URT_CFG_RPC_SERVICEID_WIDTH)
+#   error "URT_CFG_RPC_SERVICEID_WIDTH not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_RPC_SERVICEID_WIDTH) */
+
+# if !defined(URT_CFG_RPC_PROFILING)
+#   error "URT_CFG_RPC_PROFILING not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_RPC_PROFILING) */
+
+# if !defined(URT_CFG_RPC_QOS_DEADLINECHECKS)
+#   error "URT_CFG_RPC_QOS_DEADLINECHECKS not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_RPC_QOS_DEADLINECHECKS) */
+
+# if !defined(URT_CFG_RPC_QOS_JITTERCHECKS)
+#   error "URT_CFG_RPC_QOS_JITTERCHECKS not defined in urtwareconf.h"
+# endif /* !defined(URT_CFG_RPC_QOS_JITTERCHECKS) */
+
+#endif /* URT_CFG_RPC_ENABLED == true */
+
+/*============================================================================*/
+/* DATA STRUCTURES AND TYPES                                                  */
+/*============================================================================*/
+
+/*============================================================================*/
+/* MACROS                                                                     */
+/*============================================================================*/
+
+/*============================================================================*/
+/* EXTERN DECLARATIONS                                                        */
+/*============================================================================*/
+
+/*============================================================================*/
+/* INLINE FUNCTIONS                                                           */
+/*============================================================================*/
+
+#endif /* URT_CONFCHECK_H */